#ifndef _AICOMMON  
#define _AICOMMON

#include "Keys.h"
#include "Remap.h"

#define kScreenDepth					16
#define kMaskDepth						1

	// terrain
	#define							kGround										1
	#define							kWater										2
	#define							kBlackHome								3
	#define							kRedHome									4
	#define							kPoison										5
	#define							kFood											6

	#define							kMaxWater									15
	#define							kMaxPoison								8
	#define							kMaxFood									20

	#define							kRedHomeRow								5
	#define							kRedHomeCol								5
	
	#define							kBlackHomeRow							5
	#define							kBlackHomeCol							36

	// entities
	#define							kMaxEntities							200
	
	#define							kRedAnt										1
	#define							kBlackAnt									2
	#define							kTree											3

	#define							kEntitySpeed							30
	#define							kPlayerSpeed							4

	// entity states
	#define							kForage										1
	#define							kGoHome										2
	#define							kGuard										3
	#define							kThirsty									4
	#define							kDead											5

	#define							kChaseDistance						7
	#define							kMaxPathLength						200

	// world constants
	#define							kMaxRows									32
	#define							kMaxCols									42
	#define							kMaxTiles									10

	// world constants
	#define							kUpKey										1
	#define							kDownKey									2
	#define							kLeftKey									3
	#define							kRightKey									4

class	ai_Entity
{
	public:
	int												type;
	int												state;
	int												row;
	int												col;
	unsigned long							timeToMove;
	
	ai_Entity();
	~ai_Entity();
	void Forage(void);
	void GoHome(void);
	void Thirsty(void);
	void Dead(void);
	void New(int theType, int theState, int theRow, int theCol);
	int  DistanceFrom(int t);

};
//--------------------------------------------------------------
class	ai_World
{
	public:	
	ai_World();
	~ai_World();
	void Redraw(void);
	void UpdateWorld(void);
};

#endif