#ifndef _AICOMMON  
#define _AICOMMON

#include "Keys.h"
#include "Remap.h"

#define kScreenDepth					16
#define kMaskDepth						1

	// terrain
	#define							kGround										1
	#define							kWater										2
	#define							kBridge										3
	#define							kRed											4

	// entities
	#define							kMaxEntities							20
	
	#define							kHuman										1
	#define							kTroll										2
	#define							kTree											3

	#define							kEntitySpeed							30
	#define							kPlayerSpeed							4

	// entity states
	#define							kPlayer										1
	#define							kStatic										2
	#define							kPatrolling								3
	#define							kChasing									4
	#define							kPatrollingChasing				5

	#define							kChaseDistance						7
	#define							kMaxPathLength						30

	// world constants
	#define							kMaxRows									20
	#define							kMaxCols									30
	#define							kMaxTiles									10

	// world constants
	#define							kUpKey										1
	#define							kDownKey									2
	#define							kLeftKey									3
	#define							kRightKey									4

class	ai_Entity
{
	public:
	int												row;
	int												col;
	int												type;
	int												state;
	int												startRow;
	int												startCol;
	int												endRow;
	int												endCol;
	int												target;
	int												pathRow[kMaxPathLength];
	int												pathCol[kMaxPathLength];
	int												pathRowTarget;
	int												pathColTarget;
	int												pathPtr;
	unsigned long							timeToMove;
	
	ai_Entity();
	~ai_Entity();
	
	void nextStepToTarget				(int *nextRow, int *nextCol);
	void BuildPathToTarget			(void);
	void FollowPath							(void);
	void ShowPath								(void);
	void New										(int theType, int theState, int theStartRow, int theStartCol, int theEndRow, int theEndCol);
	void StartChase							(void);
	void ResetPatrol						(void);
	int  DistanceFrom						(int t);

};
//--------------------------------------------------------------
class	ai_World
{
	public:

	TBoolean									showPath;
	
	ai_World();
	~ai_World();
	void ShowPath2				(int Ax, int Ay, int Bx, int By, int *nextRow, int *nextCol);
	void SimpleShowPath		(int Ax, int Ay, int Bx, int By, int *nextRow, int *nextCol);
	void Redraw						(void);
	void UpdateWorld			(void);
	void KeyDown					(int key);

};

#endif