#ifndef _TOOLBOX
#define _TOOLBOX

#include <sound.h>
#include <QDOffscreen.h>
#include <Menus.h>
#include <MacWindows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <AppleEvents.h>
#include <Movies.h>
#include <Gestalt.h>
#include <Events.h>
#include <Traps.h>
#include <Timer.h>
#include <Limits.h>
#include <palettes.h>
#include <Controls.h>
#include <balloons.h>
#include <Printing.h>
#include <PictUtils.h>
#include <FixMath.h>
#include <StandardFile.h>
#include <ImageCompression.h>
#include <Folders.h>
#include <NumberFormatting.h>
#include <InternetConfig.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "Remap.h"
#include "Keys.h"

#define	Debug									true

#define	tbPI									3.14159265359

#define kOKButton							1
#define kCancelButton					2

#define	kTETextBox							2
#define	TheControl 				 	 	3
#define	enterKey  						3
#define	CR  									13
#define	Home  								115
#define	Bottom  							119
#define	PageU  								116
#define	PageD  								121
#define	ArrowUp  							30
#define	ArrowDown  						31

#define	ErrorMsgLg						128
#define	tb_StringLength				128
#define	kStringLength         128

#define	tb_TextOr							1
#define	tb_TextCopy						2

#define	tb_Plain							0
#define	tb_Bold								1
#define	tb_Italic							2
#define	tb_Outline						4
#define	tb_Shadow							8
#define	tb_Underline					16

#define tb_Left								1
#define tb_Center							2
#define tb_Right							3

#define	tb_MaxRegionsPoints		15
#define	kMemBitmap						-1

#define	MaxGWorlds						100
#define	MaxWindows						50
#define MaxRegions						100
#define	MaxCursors						30
#define	GWorldError						-1
#define	WindowError						-1		
#define WINBITMAP(w)					(((GrafPtr)(w))->portBits)
#define CopyPStr(dst,src)  		BlockMove(src,dst,src[0]+1)

#define kMillionsColors				32
#define kThousandsColors			16
#define	k256Colors						8
#define	k16Colors							4
#define	k4Colors							2
#define	k2Colors							1

#define	kGrayMode							0
#define	kColorMode						1

extern  ModalFilterUPP 	  myGenericFilter;

int 			tb_Rnd (int min, int max);
void 			tb_InitializeToolbox(void);
void 			tb_CloseToolbox(void);
TBitmap 	tb_CreateBitmap(TRect *r, int Picture, int Depth);
void 			tb_CopyMaskBitmap(TBitmap srcBitmap, TBitmap maskBitmap, TBitmap dstBitmap, TRect *srcRect, TRect *maskRect, TRect *dstRect);
void 			tb_CopyBitmap(TBitmap srcBitmap, TBitmap dstBitmap, TRect *srcRect, TRect *dstRect, TBoolean Transparent);
TBoolean 	tb_IsKeyDown (short KeyCode);
void		 	tb_FlushMouseEvents(void);
int 			tb_SetWindowPtr(WindowPtr w);
int 			tb_DoDialog(int id);
int 			tb_GetWindowMatch(WindowPtr wp);

#endif //  _TOOLBOX